
#include <avr/io.h>
#include <util/delay.h>
#include <avr/interrupt.h>
#include <stdio.h>
#include <stdlib.h>

#define SHIFT1 PB0
#define STORE1 PB1
#define DATA1 PB3

#define SHIFT2 PD0
#define STORE2 PD1
#define DATA2 PD4

#define LOW 0
#define HIGH 1

#define LSBFIRST 0
#define MSBFIRST 1

#define SPEED 50

int check = 0;

// matricea care reprezinta primul jucator
int player1[8][8] = {{0, 0, 0, 0, 0, 1, 0, 0},
					 {0, 0, 0, 0, 0, 1, 0, 0},
					 {0, 0, 1, 0, 0, 1, 0, 0},
					 {0, 0, 1, 0, 0, 0, 0, 0},
					 {0, 0, 0, 0, 0, 0, 0, 0},
					 {0, 0, 0, 0, 0, 0, 0, 0},
					 {0, 0, 0, 0, 0, 0, 0, 0},
					 {0, 0, 0, 0, 0, 0, 0, 0}};

int table1[8] = {0, 0, 0, 0, 0, 0, 0, 0};

// ce vede primul jucator
int player1_see[8][8] = {{0, 0, 0, 0, 0, 0, 0, 0},
					 	 {0, 0, 0, 0, 0, 0, 0, 0},
					 	 {0, 0, 0, 0, 0, 0, 0, 0},
					 	 {0, 0, 0, 0, 0, 0, 0, 0},
					 	 {0, 0, 0, 0, 0, 0, 0, 0},
					 	 {0, 0, 0, 0, 0, 0, 0, 0},
					 	 {0, 0, 0, 0, 0, 0, 0, 0},
					 	 {0, 0, 0, 0, 0, 0, 0, 0}};
int table1_see[8] = {0, 0, 0, 0, 0, 0, 0, 0};

// matricea care reprezinta al doilea jucator
int player2[8][8] = {{0, 0, 0, 0, 0, 0, 0, 0},
					 {0, 0, 1, 0, 0, 0, 0, 0},
					 {0, 0, 1, 0, 0, 0, 0, 0},
					 {0, 0, 0, 0, 0, 0, 1, 0},
					 {0, 1, 0, 0, 0, 0, 1, 0},
					 {0, 1, 0, 0, 0, 0, 1, 0},
					 {0, 1, 0, 0, 1, 0, 0, 0},
					 {0, 0, 0, 0, 1, 0, 0, 0}};

int table2[8] = {0, 0, 0, 0, 0, 0, 0, 0};

// ce vede am doilea jucator
int player2_see[8][8] = {{0, 0, 0, 0, 0, 0, 0, 0},
					 	 {0, 0, 0, 0, 0, 0, 0, 0},
					 	 {0, 0, 0, 0, 0, 0, 0, 0},
					 	 {0, 0, 0, 0, 0, 0, 0, 0},
					 	 {0, 0, 0, 0, 0, 0, 0, 0},
					 	 {0, 0, 0, 0, 0, 0, 0, 0},
					 	 {0, 0, 0, 0, 0, 0, 0, 0},
					 	 {0, 0, 0, 0, 0, 0, 0, 0}};
int table2_see[8] = {0, 0, 0, 0, 0, 0, 0, 0};

//------------------------------------------------

// matrice pentru invingator
int winner[8][8] = {{0, 0, 0, 0, 0, 0, 0, 0},
			 	 {1, 0, 0, 0, 0, 0, 1, 0},
			 	 {1, 0, 0, 0, 0, 0, 1, 0},
			 	 {0, 1, 0, 0, 0, 0, 0, 1},
			 	 {0, 1, 0, 0, 0, 0, 0, 1},
			 	 {0, 0, 1, 0, 0, 1, 0, 0},
			 	 {0, 0, 1, 0, 0, 1, 0, 0},
			 	 {0, 0, 0, 1, 1, 0, 0, 0}};
int table_winner[8] = {0, 0, 0, 0, 0, 0, 0, 0};

// matrice cu o fata zambitoare
int happy[8][8] = {{0, 0, 0, 0, 0, 0, 0, 0},
			 	 {0, 0, 1, 0, 0, 1, 0, 0},
			 	 {0, 0, 1, 0, 0, 1, 0, 0},
			 	 {0, 0, 1, 0, 0, 1, 0, 0},
			 	 {0, 0, 0, 0, 0, 0, 0, 0},
			 	 {0, 1, 0, 0, 0, 0, 1, 0},
			 	 {0, 0, 1, 1, 1, 1, 0, 0},
			 	 {0, 0, 0, 0, 0, 0, 0, 0}};
int table_happy[8] = {0, 0, 0, 0, 0, 0, 0, 0};

// matrice pentru pierzator
int loser[8][8] = {{0, 0, 0, 0, 0, 0, 0, 0},
			 	 {0, 0, 1, 0, 0, 0, 0, 0},
			 	 {0, 0, 1, 0, 0, 0, 0, 0},
			 	 {0, 0, 1, 0, 0, 0, 0, 0},
			 	 {0, 0, 1, 0, 0, 0, 0, 0},
			 	 {0, 0, 1, 0, 0, 0, 0, 0},
			 	 {0, 0, 1, 1, 1, 1, 0, 0},
			 	 {0, 0, 0, 0, 0, 0, 0, 0}};
int table_loser[8] = {0, 0, 0, 0, 0, 0, 0, 0};

// fata trista
int sad[8][8] = {{0, 0, 0, 0, 0, 0, 0, 0},
			 	 {0, 0, 1, 0, 0, 1, 0, 0},
			 	 {0, 0, 1, 0, 0, 1, 0, 0},
			 	 {0, 0, 1, 0, 0, 1, 0, 0},
			 	 {0, 0, 0, 0, 0, 0, 0, 0},
			 	 {0, 0, 1, 1, 1, 1, 0, 0},
			 	 {0, 1, 0, 0, 0, 0, 1, 0},
			 	 {0, 0, 0, 0, 0, 0, 0, 0}};

int table_sad[8] = {0, 0, 0, 0, 0, 0, 0, 0};

// variabile ajutatoare
int ship1_x = 1;
int ship1_y = 1;
int ship1_x_old = 1;
int ship1_y_old = 1;
int old_val = player1[1][1];

int ship2_x = 1;
int ship2_y = 1;
int ship2_x_old = 1;
int ship2_y_old = 1;

/* urmatoarele 8 functii sunt pentru convertit
 * liniile matricilor in numere
 */
void convert1(void)
{
	int i, j, k;
	for(i = 0; i < 8; i++) {
		table1[i] = 0;
		for(j = 7; j >= 0; j--) {
			if(player1[i][j] == 1) {
				int aux = 1;
				for(k = 1; k <= 7 - j; k++) {
					aux *= 2;
				}
				table1[i] += aux;
			}
		}
	}
}

void convert1_see(void)
{
	int i, j, k;
	for(i = 0; i < 8; i++) {
		table1_see[i] = 0;
		for(j = 7; j >= 0; j--) {
			if(player1_see[i][j] == 1) {
				int aux = 1;
				for(k = 1; k <= 7 - j; k++) {
					aux *= 2;
				}
				table1_see[i] += aux;
			}
		}
	}
}

void convert1_final(void)
{
	int i, j, k;
	for(i = 0; i < 8; i++) {
		table_winner[i] = 0;
		for(j = 7; j >= 0; j--) {
			if(winner[i][j] == 1) {
				int aux = 1;
				for(k = 1; k <= 7 - j; k++) {
					aux *= 2;
				}
				table_winner[i] += aux;
			}
		}
	}
}

void convert1_see_final(void)
{
	int i, j, k;
	for(i = 0; i < 8; i++) {
		table_happy[i] = 0;
		for(j = 7; j >= 0; j--) {
			if(happy[i][j] == 1) {
				int aux = 1;
				for(k = 1; k <= 7 - j; k++) {
					aux *= 2;
				}
				table_happy[i] += aux;
			}
		}
	}
}

void convert2(void)
{
	int i, j, k;
	for(i = 0; i < 8; i++) {
		table2[i] = 0;
		for(j = 7; j >= 0; j--) {
			if(player2[i][j] == 1) {
				int aux = 1;
				for(k = 1; k <= 7 - j; k++) {
					aux *= 2;
				}
				table2[i] += aux;
			}
		}
	}
}

void convert2_see(void)
{
	int i, j, k;
	for(i = 0; i < 8; i++) {
		table2_see[i] = 0;
		for(j = 7; j >= 0; j--) {
			if(player2_see[i][j] == 1) {
				int aux = 1;
				for(k = 1; k <= 7 - j; k++) {
					aux *= 2;
				}
				table2_see[i] += aux;
			}
		}
	}
}

void convert2_final(void)
{
	int i, j, k;
	for(i = 0; i < 8; i++) {
		table_loser[i] = 0;
		for(j = 7; j >= 0; j--) {
			if(loser[i][j] == 1) {
				int aux = 1;
				for(k = 1; k <= 7 - j; k++) {
					aux *= 2;
				}
				table_loser[i] += aux;
			}
		}
	}
}

void convert2_see_final(void)
{
	int i, j, k;
	for(i = 0; i < 8; i++) {
		table_sad[i] = 0;
		for(j = 7; j >= 0; j--) {
			if(sad[i][j] == 1) {
				int aux = 1;
				for(k = 1; k <= 7 - j; k++) {
					aux *= 2;
				}
				table_sad[i] += aux;
			}
		}
	}
}

// initializez ADC-ul
void ADC_init(void)
{
    ADMUX = (1 << REFS0);
    ADCSRA = (1 << ADEN) | (5 << ADPS0);
}

// initializez dispozitivele de input si output
void IO_init(void)
{
	//SW1
	DDRC &= ~(1 << PC6);
	PORTC |= (1 << PC6);

	//SW2
	DDRC &= ~(1 << PC4);
	PORTC |= (1 << PC4);

	//BUTTON
	DDRB &= ~(1 << PB2);
	PORTB |= (1 << PB2);

	// SHIFT REGISTER Player1
	DDRB |= (1 << PB0) | (1 << PB1) | (1 << PB3);

	PORTB &= ~(1 << PB0); //CLK = SHIFT
	PORTB &= ~(1 << PB1); //LATCH = STORE
	PORTB &= ~(1 << PB3); //DATA

	// SHIFT REGISTER Player2
	DDRD |= (1 << PD0) | (1 << PD1) | (1 << PD4);

	PORTD &= ~(1 << PD0); //CLK = SHIFT
	PORTD &= ~(1 << PD1); //LATCH = STORE
	PORTD &= ~(1 << PD4); //DATA
}

// extrag valoarea raw cu ADC
uint16_t ADC_get(uint8_t channel)
{
    ADMUX = (ADMUX & ~(0x1f << MUX0)) | channel;

    ADCSRA |= (1 << ADSC);
    while(ADCSRA & (1 << ADSC));

    return ADC;
}

// scriere valoare pe pin
void digitalWrite1(uint8_t pin, uint8_t value)
{
	if (value == LOW) {
		PORTB &= ~(1 << pin);
	} else {
		PORTB |= (1 << pin);
	}
}

void digitalWrite2(uint8_t pin, uint8_t value)
{
	if (value == LOW) {
		PORTD &= ~(1 << pin);
	} else {
		PORTD |= (1 << pin);
	}
}

// incarcare valoare
void store1()
{
	PORTB |= (1 << STORE1);
	_delay_us(10);
	PORTB &= ~(1 << STORE1);
	_delay_us(10);
}

void store2()
{
	PORTD |= (1 << STORE2);
	_delay_us(10);
	PORTD &= ~(1 << STORE2);
	_delay_us(10);
}

// shiftare de pe un registru de deplasare pe altul
void shiftOut1(uint8_t dataPin, uint8_t clockPin, uint8_t bitOrder, uint8_t val)
{

	uint8_t i;
	digitalWrite1(clockPin, LOW);	
	for (i = 0; i < 8; i++)  {
		if (bitOrder == LSBFIRST)
			digitalWrite1(dataPin, !!(val & (1 << i)));
		else	
			digitalWrite1(dataPin, !!(val & (1 << (7 - i))));
		digitalWrite1(clockPin, HIGH);
		digitalWrite1(clockPin, LOW);	
	}
}

void shiftOut2(uint8_t dataPin, uint8_t clockPin, uint8_t bitOrder, uint8_t val)
{

	uint8_t i;
	digitalWrite2(clockPin, LOW);	
	for (i = 0; i < 8; i++)  {
		if (bitOrder == LSBFIRST)
			digitalWrite2(dataPin, !!(val & (1 << i)));
		else	
			digitalWrite2(dataPin, !!(val & (1 << (7 - i))));
		digitalWrite2(clockPin, HIGH);
		digitalWrite2(clockPin, LOW);	
	}
}

// se afiseaza pe matricile de led-uri situatiile celor 2 jucatori
void print_matrix(int i) {
	convert1();
	convert1_see();
	convert2();
	convert2_see();
	if(i == 1) {
		for(i = 0; i < 8; i++) {
			shiftOut1(DATA1, SHIFT1, LSBFIRST, ~table1[i]);
			shiftOut1(DATA1, SHIFT1, LSBFIRST, ~table1_see[i]);
			shiftOut1(DATA1, SHIFT1, LSBFIRST, 128 >> i);
			store1();
		}
	} else {
		for(i = 0; i < 8; i++) {
			shiftOut2(DATA2, SHIFT2, LSBFIRST, ~table2[i]);
			shiftOut2(DATA2, SHIFT2, LSBFIRST, ~table2_see[i]);
			shiftOut2(DATA2, SHIFT2, LSBFIRST, 128 >> i);
			store2();
		}
	}
}

// folosite pentru afisarea fetei zambitoare/triste
void print_matrix_final_1(int i) {
	convert1_final();
	convert1_see_final();
	convert2_final();
	convert2_see_final();
	if(i == 1) {
		for(i = 0; i < 8; i++) {
			shiftOut1(DATA1, SHIFT1, LSBFIRST, ~table_winner[i]);
			shiftOut1(DATA1, SHIFT1, LSBFIRST, ~table_happy[i]);
			shiftOut1(DATA1, SHIFT1, LSBFIRST, 128 >> i);
			store1();
		}
	} else {
		for(i = 0; i < 8; i++) {
			shiftOut2(DATA2, SHIFT2, LSBFIRST, ~table_loser[i]);
			shiftOut2(DATA2, SHIFT2, LSBFIRST, ~table_sad[i]);
			shiftOut2(DATA2, SHIFT2, LSBFIRST, 128 >> i);
			store2();
		}
	}
}

void print_matrix_final_2(int i) {
	convert1_final();
	convert1_see_final();
	convert2_final();
	convert2_see_final();

	if(i == 1) {
		for(i = 0; i < 8; i++) {
			shiftOut1(DATA1, SHIFT1, LSBFIRST, ~table_loser[i]);
			shiftOut1(DATA1, SHIFT1, LSBFIRST, ~table_sad[i]);
			shiftOut1(DATA1, SHIFT1, LSBFIRST, 128 >> i);
			store1();
		}
	} else {
		for(i = 0; i < 8; i++) {
			shiftOut2(DATA2, SHIFT2, LSBFIRST, ~table_winner[i]);
			shiftOut2(DATA2, SHIFT2, LSBFIRST, ~table_happy[i]);
			shiftOut2(DATA2, SHIFT2, LSBFIRST, 128 >> i);
			store2();
		}
	}
}

void print_both(void) {
	print_matrix(1);
	print_matrix(2);
}

// primul jucator isi plaseaza navele
void place_ships1(void) {
	// variabilă folosită pentru a încetini cursorul când se deplasează
	int count_movez = SPEED;
	int count_ships = 5;
	int pushed = 10;

	while(1) {

		// se verifica dacă s-a apăsat vreun buton
		if((PINB & (1 << PB2)) == 0 || (PINC & (1 << PC6)) == 0) {
			
			if(pushed < 0) {
				count_ships--;
				player1[ship1_y][ship1_x] = 1;
				old_val = 1;

				pushed = 10;
			} else {
				pushed--;
			}
		}
			
		int moved = 0;
		int x, y;

		x = ADC_get(0);
		y = ADC_get(1);

		// se verifică dacă s-a mișcat joystick-ul pe axa Ox
		if(x > 700 || x < 300) {
			if(x > 700) {
				if(count_movez == 0) {
					ship1_x++;
					count_movez = SPEED;
					moved = 1;
				} else {
					count_movez--;
				}
			} else {
				if(count_movez == 0) {
					ship1_x--;
					count_movez = SPEED;
					moved = 1;
				} else {
					count_movez--;
				}
			}
			
		}

		// se verifică dacă s-a mișcat joystick-ul pe axa Oy
		if(y > 700 || y < 300) {
			if(y > 700) {
				if(count_movez == 0) {
					ship1_y++;
					count_movez = SPEED;
					moved = 1;
				} else {
					count_movez--;
				}
			} else {
				if(count_movez == 0) {
					ship1_y--;
					count_movez = SPEED;
					moved = 1;
				} else {
					count_movez--;
				}
			}
		}

		// se reseteaza poziția cursorului dacă s-a ajuns la marginea matricei
		if(ship1_y >= 8 || ship1_y < 0) {
			ship1_y = 1;
		}

		if(ship1_x >= 8 || ship1_x < 0) {
			ship1_x = 1;
		}

		// se face o actualizare a poziției cursorului
		if(moved == 1) {
			player1[ship1_y_old][ship1_x_old] = old_val;

			old_val = player1[ship1_y][ship1_x];

			player1[ship1_y][ship1_x] = 1;

			ship1_x_old = ship1_x;
			ship1_y_old = ship1_y;
			moved = 0;
		}
		

		if(count_ships < 0) {
			break;
		}
		print_both();
	}
}

// al doilea jucator isi plaseaza navele
void place_ships2(void) {
	// variabilă folosită pentru a încetini cursorul când se deplasează
	int count_movez = SPEED;
	int count_ships = 5;
	int pushed = 10;

	while(1) {

		// se verifica dacă s-a apăsat vreun buton
		if((PINB & (1 << PB2)) == 0 || (PINC & (1 << PC4)) == 0) {
			
			if(pushed < 0) {
				count_ships--;
				player2[ship2_y][ship2_x] = 1;
				old_val = 1;

				pushed = 10;
			} else {
				pushed--;
			}
		}
			
		int moved = 0;
		int x, y;

		x = ADC_get(3);
		y = ADC_get(4);

		// se verifică dacă s-a mișcat joystick-ul pe axa Ox
		if(x > 700 || x < 300) {
			if(x > 700) {
				if(count_movez == 0) {
					ship2_x++;
					count_movez = SPEED;
					moved = 1;
				} else {
					count_movez--;
				}
			} else {
				if(count_movez == 0) {
					ship2_x--;
					count_movez = SPEED;
					moved = 1;
				} else {
					count_movez--;
				}
			}
			
		}

		// se verifică dacă s-a mișcat joystick-ul pe axa Oy
		if(y > 700 || y < 300) {
			if(y > 700) {
				if(count_movez == 0) {
					ship2_y++;
					count_movez = SPEED;
					moved = 1;
				} else {
					count_movez--;
				}
			} else {
				if(count_movez == 0) {
					ship2_y--;
					count_movez = SPEED;
					moved = 1;
				} else {
					count_movez--;
				}
			}
		}

		// se reseteaza poziția cursorului dacă s-a ajuns la marginea matricei
		if(ship2_y >= 8 || ship2_y < 0) {
			ship2_y = 1;
		}

		if(ship2_x >= 8 || ship2_x < 0) {
			ship2_x = 1;
		}

		// se face o actualizare a poziției cursorului
		if(moved == 1) {
			player2[ship2_y_old][ship2_x_old] = old_val;

			old_val = player2[ship2_y][ship2_x];

			player2[ship2_y][ship2_x] = 1;

			ship2_x_old = ship2_x;
			ship2_y_old = ship2_y;
			moved = 0;
		}
		

		if(count_ships < 0) {
			break;
		}
		print_both();
	}
}

//------------------------------------------------------

// primul jucator executa o mutare
void player1_move(void) {
	// variabilă folosită pentru a încetini cursorul când se deplasează
	int count_movez = SPEED;

	while(1) {

		// se verifica dacă s-a apăsat vreun buton
		if((PINB & (1 << PB2)) == 0 || (PINC & (1 << PC6)) == 0) {
			
			player2[ship1_y][ship1_x] = 0;
			player1_see[ship1_y][ship1_x] = 1;
			old_val = 1;
			break;
		}
			
		int moved = 0;
		int x, y;

		x = ADC_get(0);
		y = ADC_get(1);

		// se verifică dacă s-a mișcat joystick-ul pe axa Ox
		if(x > 700 || x < 300) {
			if(x > 700) {
				if(count_movez == 0) {
					ship1_x++;
					count_movez = SPEED;
					moved = 1;
				} else {
					count_movez--;
				}
			} else {
				if(count_movez == 0) {
					ship1_x--;
					count_movez = SPEED;
					moved = 1;
				} else {
					count_movez--;
				}
			}
			
		}

		// se verifică dacă s-a mișcat joystick-ul pe axa Oy
		if(y > 700 || y < 300) {
			if(y > 700) {
				if(count_movez == 0) {
					ship1_y++;
					count_movez = SPEED;
					moved = 1;
				} else {
					count_movez--;
				}
			} else {
				if(count_movez == 0) {
					ship1_y--;
					count_movez = SPEED;
					moved = 1;
				} else {
					count_movez--;
				}
			}
		}

		// se reseteaza poziția cursorului dacă s-a ajuns la marginea matricei
		if(ship1_y >= 8 || ship1_y < 0) {
			ship1_y = 1;
		}

		if(ship1_x >= 8 || ship1_x < 0) {
			ship1_x = 1;
		}

		// se face o actualizare a poziției cursorului
		if(moved == 1) {
			player1_see[ship1_y_old][ship1_x_old] = old_val;

			old_val = player1_see[ship1_y][ship1_x];

			player1_see[ship1_y][ship1_x] = 1;

			ship1_x_old = ship1_x;
			ship1_y_old = ship1_y;
			moved = 0;
		}
		
		print_both();
	}
}

// al doilea jucator executa o mutare
void player2_move(void) {
	int count_movez = SPEED;

	while(1) {

		// se verifica dacă s-a apăsat vreun buton
		if((PINB & (1 << PB2)) == 0 || (PINC & (1 << PC4)) == 0) {
			
			player1[ship2_y][ship2_x] = 0;
			player2_see[ship2_y][ship2_x] = 1;
			old_val = 1;
			break;
		}
			
		int moved = 0;
		int x, y;

		x = ADC_get(3);
		y = ADC_get(4);

		// se verifică dacă s-a mișcat joystick-ul pe axa Ox
		if(x > 700 || x < 300) {
			if(x > 700) {
				if(count_movez == 0) {
					ship2_x++;
					count_movez = SPEED;
					moved = 1;
				} else {
					count_movez--;
				}
			} else {
				if(count_movez == 0) {
					ship2_x--;
					count_movez = SPEED;
					moved = 1;
				} else {
					count_movez--;
				}
			}
			
		}

		// se verifică dacă s-a mișcat joystick-ul pe axa Oy
		if(y > 700 || y < 300) {
			if(y > 700) {
				if(count_movez == 0) {
					ship2_y++;
					count_movez = SPEED;
					moved = 1;
				} else {
					count_movez--;
				}
			} else {
				if(count_movez == 0) {
					ship2_y--;
					count_movez = SPEED;
					moved = 1;
				} else {
					count_movez--;
				}
			}
		}

		// se reseteaza poziția cursorului dacă s-a ajuns la marginea matricei
		if(ship2_y >= 8 || ship2_y < 0) {
			ship2_y = 1;
		}

		if(ship2_x >= 8 || ship2_x < 0) {
			ship2_x = 1;
		}

		// se face o actualizare a poziției cursorului
		if(moved == 1) {
			player2_see[ship2_y_old][ship2_x_old] = old_val;

			old_val = player2_see[ship2_y][ship2_x];

			player2_see[ship2_y][ship2_x] = 1;

			ship2_x_old = ship2_x;
			ship2_y_old = ship2_y;
			moved = 0;
		}
		
		print_both();
	}
}

// se incepe lupta
void start_fight(void) {

	check = 0;
	int sum;
	int i;

	while(1) {
		/* se verifica daca vreunul din jucatori a reusit
		 * a reusit sa doboare toate celelalte nave
		 */
		convert1();
		convert2();
		sum = 0;
		for(i = 0; i < 8; i++) {
			sum += table1[i];
		}

		if(sum == 0) {
			check = 1;
		}

		sum = 0;
		for(i = 0; i < 8; i++) {
			sum += table2[i];
		}

		if(sum == 0) {
			check = 2;
		}

		if(check != 0) {
			break;
		}
		
		player1_move();
		player2_move();
	}
}

void print_final1(void)
{
	print_matrix_final_1(1);
	print_matrix_final_1(2);
}

void print_final2(void)
{
	print_matrix_final_2(1);
	print_matrix_final_2(2);
}

int main()
{
	ADC_init();
	IO_init();

	place_ships1();

	old_val = player2[1][1];

	place_ships2();

	start_fight();

	if(check != 1) {
		while(1)
			print_final1();
	} else {
		while(1)
			print_final2();
	}

	return 0;
}
